import java.util.*;

public class Main
    implements AlignmentListener
{
  public void areAligned(Planet p1, Planet p2, Planet p3)
  {
    System.out.println("all " + p1.getName() + ":" + p2.getName() +
        ":" + p3.getName());
  }

  public void areRect(Planet p1, Planet p2, Planet p3)
  {
    System.out.println("rect " + p1.getName() + ":" + p2.getName() +
        ":" + p3.getName());
  }

  public static void main(String[] args)
  {
    PlanetObserver o = new PlanetObserver(0.01);
    for (Planet p : Planet.values())
      p.addListener(o);
    o.addListener(new Main());

    Scanner sc = new Scanner(System.in);
    double earthWeight = Double.parseDouble(args[0]);
    double mass = earthWeight / Planet.EARTH.getSurfaceGravity();

    for (Planet p : Planet.values())
      System.out.printf("Your weight on %s is %f\n", p, p.getSurfaceWeight(mass));

    String choice = null;
    do
    {
      for (Planet p : Planet.values())
        System.out.println(p.toString());
      System.out.println("again (y/n)?");
      choice = sc.nextLine();
    }
    while ("y".equalsIgnoreCase(choice));
    Planet.stop();
  }

}
