import java.util.*;

public class PlanetObserver
    extends Geobserver<Planet>
    implements PlanetListener
{
  private List<AlignmentListener> m_listeners = new ArrayList<AlignmentListener>();

  public void addListener(AlignmentListener l)
  {
    m_listeners.add(l);
  }

  public void removeListener(AlignmentListener l)
  {
    m_listeners.remove(l);
  }

  private void dispatchAlignment(Planet p1, Planet p2, Planet p3)
  {
    for (AlignmentListener l : m_listeners)
      l.areAligned(p1, p2, p3);
  }

  private void dispatchRect(Planet p1, Planet p2, Planet p3)
  {
    for (AlignmentListener l : m_listeners)
      l.areRect(p1, p2, p3);
  }

  public PlanetObserver(double toll)
  {
    super(toll);
  }

  public void planetMoved(Planet p)
  {
//    System.out.println(">>>>" + p.getName() + ":" + p.getAngle());
    for (Planet p1 : Planet.values())
      for (Planet p2 : Planet.values())
        if (p1 != p && p2 != p && p1 != p2)
        {
          if (checkAlignment(p, p1, p2))
            dispatchAlignment(p, p1, p2);
          if (checkRect(p, p1, p2))
            dispatchRect(p, p1, p2);
          if (checkRect(p1, p, p2))
            dispatchRect(p1, p, p2);
          if (checkRect(p2, p, p1))
            dispatchRect(p2, p, p1);
        }
  }

}
